using System;
using System.Web;
using Jenzabar.Portal.Framework;
using Jenzabar.Portal.Framework.Web.UI;
using Jenzabar.ICS.Web.Portlets.LoginPortlet;

namespace CUS.ICS.LoginCaptureCrypto
{
	/// <summary>
	/// Summary description for FeithSignonLoginPageProvider.
	/// </summary>
	public class LoginCaptureCrypto
	{
		public LoginCaptureCrypto()
		{
			// nothing really here
		}
	}
	public class Password
	{
		public static string Current
		{
			set
			{
				SymmetricCryptographerBase64 cryptic = new SymmetricCryptographerBase64(HttpContext.Current.Session.SessionID.ToString());
				HttpContext.Current.Session[LCCConstants.SESSION_PASSWORD_KEY] = cryptic.Encrypt(value);
			}
			get
			{
				if (HttpContext.Current.Session[LCCConstants.SESSION_PASSWORD_KEY] != null && 
					HttpContext.Current.Session[LCCConstants.SESSION_PASSWORD_KEY].ToString().Trim().Length > 0)
				{
					SymmetricCryptographerBase64 cryptic = new SymmetricCryptographerBase64(HttpContext.Current.Session.SessionID.ToString());
					return cryptic.Decrypt(HttpContext.Current.Session[LCCConstants.SESSION_PASSWORD_KEY].ToString());
				}
				else
				{
					return string.Empty;
				}
			}
		}	
	}
	public class LoginCaptureCryptoPageProvider : ILoginPageProvider
	{
		public bool HasLoginPagesFor(UserLoginData loginInfo)
		{
			// If you return true here, you need to have corresponding page path defined in  GetNextLoginPage
			// If you return false here, you need not have any corresponding page designated in the  GetNextLoginPage class
			// You can insert any test logic you want to determine whether the current user has more login pages to view

			if (loginInfo.LoginState["password"] == null || 
				loginInfo.LoginState["password"].ToString().Length == 0 ||
				(loginInfo.LoginState[LCCConstants.LOGIN_DONE] != null &&
				loginInfo.LoginState[LCCConstants.LOGIN_DONE] is bool &&
				(bool)loginInfo.LoginState[LCCConstants.LOGIN_DONE]))
				return false;
			else
				return true;
		}

		public LoginPageViewBase GetNextLoginPage(UserLoginData loginInfo, PortletBase loginPortlet)
		{
			return (LoginPageViewBase)PortletViewLoader.LoadPortletView("~/Portlets/CUS/ICS/LoginCaptureCrypto/LoginPage.ascx");
		}
	}
	public class LCCConstants
	{
		// Default login pages db keys
		public static readonly string SESSION_PASSWORD_KEY = "LoginCaptureCryptoPassword";
		public static readonly string LOGIN_DONE = "LoginCaptureCryptoDone";

		public LCCConstants()
		{
		}
	}
}
